=== debian/changelog ===
neovim (0.2.0-3build2) artful; urgency=medium

  * Revert packaging change since bootstrapping is complete

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 06 Aug 2017 00:41:54 -0400

neovim (0.2.0-3build1) artful; urgency=medium

  * Drop lua-nvim from Build-Depends to bootstrap ppc64el

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 06 Aug 2017 00:16:35 -0400

neovim (0.2.0-3) unstable; urgency=medium

  * Cherry-pick b98ea042 from upstream to fix reading values of integer
    options on big-endian systems.  (Closes: #870367)

 -- James McCoy <jamessan@debian.org>  Tue, 01 Aug 2017 22:19:33 -0400

neovim (0.2.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Get the username from `id -un` instead of relying on the environment.
  * Cherry-pick 347dd947 from upstream to fix test failures related to stdin
    being /dev/null in Debian builds.

 -- James McCoy <jamessan@debian.org>  Tue, 01 Aug 2017 07:21:35 -0400

neovim (0.2.0-1) experimental; urgency=medium

  * New upstream release
    + Cursor shape/color is controlled by 'guicursor', even in the terminal.
      $NVIM_TUI_ENABLE_CURSOR_SHAPE is no longer used.
    + 'showcmd', 'ruler', and 'belloff=all' are set by default.
    + 'mouse=a' is no longer set by default.
    + debcontrol.vim: Add "rust" and "javascript" as known sections.  (Closes:
      #847541)
    + Fix test failures with msgpack-c 2.x.  (Closes: #866802)
  * Skip known flaky tests by setting $TEST_SKIP_FRAGILE.
  * Rewrite debian/rules to invoke cmake directly, instead of through
    top-level Makefile.  (Closes: #857256)
  * Bump lua-nvim Build-Depends >= 0.0.1-26-1~, needed by new tests.
  * Cherry-pick 4d017256 from upstream to fix a test failure when $HOME is a
    long path.

 -- James McCoy <jamessan@debian.org>  Sun, 02 Jul 2017 16:39:33 -0400
