=== debian/control ===
Source: neovim
Section: editors
Priority: extra
Maintainer: Debian Vim Maintainers <pkg-vim-maintainers@lists.alioth.debian.org>
Uploaders: James McCoy <jamessan@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 gperf,
 libacl1-dev,
 libjemalloc-dev [!hurd-any],
 libkvm-dev [kfreebsd-any],
 libluajit-5.1-dev [amd64 armel armhf hurd-i386 i386 kfreebsd-i386 powerpc powerpcspe],
 libmsgpack-dev (>= 1.0.0),
 libnss-wrapper <!nocheck>,
 libtermkey-dev,
 libunibilium-dev,
 libuv1-dev,
 libvterm-dev,
 lua-bitop,
 lua-busted <!nocheck>,
 lua-lpeg,
 lua-mpack,
 lua-nvim (>= 0.0.1-26-1~) [alpha amd64 armel armhf hppa i386 mips mips64el mipsel powerpc ppc64el sparc64 x32] <!nocheck>,
 luajit [amd64 armel armhf hurd-i386 i386 kfreebsd-i386 powerpc powerpcspe] | lua5.1,
 ninja-build,
 pkg-config
Standards-Version: 3.9.8
Homepage: https://neovim.io/
Vcs-Git: https://anonscm.debian.org/git/pkg-vim/neovim.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-vim/neovim.git

Package: neovim
Architecture: any
Depends:
 neovim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: python-neovim, python3-neovim, xsel | xclip, xxd
Suggests: ctags, vim-scripts
Description: heavily refactored vim fork
 Neovim is a fork of Vim focused on modern code and features, rather than
 running in legacy environments.
 .
 msgpack API enables structured communication to/from any programming language.
 Remote plugins run as co-processes that communicate with Neovim safely and
 asynchronously.
 .
 GUIs (or TUIs) can easily embed Neovim or communicate via TCP sockets using
 the discoverable msgpack API.

Package: neovim-runtime
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Breaks: neovim (<< 0.1.1-2~)
Replaces: neovim (<< 0.1.1-2~)
Description: heavily refactored vim fork (runtime files)
 Neovim is a fork of Vim focused on modern code and features, rather than
 running in legacy environments.
 .
 This package contains the architecture independent runtime files used by
 neovim.  Examples of such files are: documentation, rules for
 language-specific highlighting and indentation, color schemes, and standard
 plugins.
